function load()
	AdvTiledLoader = require("AdvTiledLoader/Loader")
	require("camera")
	require("TEsound")
	require("states/game/player")

	love.graphics.setBackgroundColor(220,220,255)
	--bg = love.graphics.newImage("textures/bg.jpg")

	AdvTiledLoader.path = "maps/"
	map = AdvTiledLoader.load("map4.tmx")
	map:setDrawRange(0, 0, map.width * map.tileWidth, map.height * map.tileHeight)

	camera:setBounds(0,0, map.width * map.tileWidth - love.graphics.getWidth(), map.height * map.tileHeight - love.graphics.getHeight())
end

function love.draw()
	camera:set()

	--love.graphics.setColor(255,255,255)
	--love.graphics.draw(bg)

	love.graphics.print("jump.frame: ".. jump.frame,16,16,0,1,1)
	love.graphics.print(player.y_vel,16,32,0,1,1)
	
	if move_right then
		if hoover.state then 
			love.graphics.drawq(sheet, anims["hoover_right"][hoover.frame], player.x - player.w/2, player.y - player.h/2)
		elseif jump.state then
			love.graphics.drawq(sheet, anims["jump"][jump.frame], player.x - player.w/2, player.y - player.h/2)
		else
			love.graphics.drawq(sheet, anims["walk_right"][walk.frame], player.x - player.w/2, player.y - player.h/2)
		end	

	elseif move_left then
		if hoover.state then 
			if walk.frame>7 then walk.frame=0 end
			love.graphics.drawq(sheet, anims["hoover_left"][walk.frame], player.x - player.w/2, player.y - player.h/2)
		elseif jump.state then
			if jump.frame>12 then jump.frame=0 end
			love.graphics.drawq(sheet, anims["jump"][jump.frame], player.x - player.w/2, player.y - player.h/2)
		else
			love.graphics.drawq(sheet, anims["walk_left"][walk.frame], player.x - player.w/2, player.y - player.h/2)
		end

	elseif shoot.state then
		love.graphics.drawq(sheet, anims["shoot"][shoot.frame], player.x - player.w/2, player.y - player.h/2)
	
	elseif jump.state then
		if walk.frame>7 then walk.frame=0 end
		love.graphics.drawq(sheet, anims["jump"][jump.frame], player.x - player.w/2, player.y - player.h/2)
	
	else
		if last_direction == 1 then 
			if jump.state then
				love.graphics.drawq(sheet, anims["jump"][jump.frame], player.x - player.w/2, player.y - player.h/2)
			else
				love.graphics.drawq(sheet, anims["idle_right"], player.x - player.w/2, player.y - player.h/2)
			end
		else	
			if jump.state then
				love.graphics.drawq(sheet, anims["jump"][jump.frame], player.x - player.w/2, player.y - player.h/2)
			else
				love.graphics.drawq(sheet, anims["idle_left"], player.x - player.w/2, player.y - player.h/2)
			end
		end
	end

	love.graphics.setColor(255,255,255)
	map:draw()

	camera:unset()
end


function love.update(dt)
	if dt > 0.05 then
		dt = 0.05
	end
	if love.keyboard.isDown("right") then
		player:right()
	end
	if love.keyboard.isDown("left") then
		player:left()
	end
	if love.keyboard.isDown("up") then
		player:jump()
	end
	if love.keyboard.isDown("z") then
		player:shoot()
	end
	if love.keyboard.isDown("lshift") then
		player:hoover()
	end

	if not love.keyboard.isDown("z") then
		shoot.state = false
	end

	if not love.keyboard.isDown("lshift") then
		hoover.state = false
	end

	player:update(dt)

	camera:setPosition(player.x - (love.graphics.getWidth()/2), player.y - (love.graphics.getHeight()/2))

end

function love.keypressed(key)
   if key == 'escape' then
    	love.event.push('q')
   end
end

function love.keyreleased(key)
	if (key =="left") or (key == "right") then
		player.x_vel = 0
		move_right = false
		move_left = false
		walk.frame=0
		walk.time=0
	end
	
	if key == 'z' then
		last_direction = 2
        shoot.state = false
		walk.frame=0
		walk.time=0
    end

    if key == 'lshift' then
		hoover.state = false
	end	
end
